;===============================================================================
; Function Name:    __FldrListToArray()
; Description:      Recursivly find the folders in a given path
; Syntax:           __FldrListToArray($szRoot, $nFlag = 1 )
; Parameter(s):     $szRoot - The base folder
;                   $iRecurs - If 1 (default) search is recursive
; Requirements:
; Return Value(s):  Success - An array of the folders with paths
;                   Failure - None
; Author(s):        George (GEOSoft) Gedye
; Notes:
;===============================================================================

Func __FldrListToArray($szRoot, $iRecurs = 1 )
	If StringRight($szRoot, 1) <> '\' Then $szRoot &= '\'
	Local $szReturn = '',  $szBuffer = '', $szPathlist = '*', $oRoot = $szRoot & '*'
		$Hfile = FileFindFirstFile ($szRoot &'*')
		If $Hfile >= 0 Then
			$szBuffer = FileFindNextFile ($Hfile)
			While NOT @Error
				If Not StringInStr($szBuffer, '.') Then $szPathlist &= $szRoot & $szBuffer & "\*"
				$szBuffer = FileFindNextFile ($Hfile)
			Wend
			FileClose ($Hfile)
		EndIf
		$szReturn = $szPathList

	If $iRecurs = 1 Then
		$szPathList = StringTrimLeft($szPathlist, 1)
		$szRoot = StringLeft($szPathList, StringInStr($szPathlist, '*') -1)
		While 1
			$hFile = FileFindFirstFile ($szRoot & '*')
			If $hFile >= 0 Then
				$szBuffer = FileFindNextFile ($Hfile)
			While NOT @Error
				If Not StringInStr($szBuffer, '.') Then
					$szPathlist &= $szRoot & $szBuffer & "\*"
					$szReturn &= $szRoot & $szBuffer & "\*"
				EndIf
				$szBuffer = FileFindNextFile ($Hfile)
			Wend
			FileClose($hFile)
			$szPathList = StringReplace($szPathList, $szRoot, '')
			EndIf
			If $szPathList == '*' Then ExitLoop
			$szPathlist = StringTrimLeft ($szPathlist, 1)
			$szRoot = StringLeft ($szPathlist, StringInStr ($szPathlist, "*") - 1) & "\"
			$szPathlist = StringTrimLeft ($szPathlist, StringInStr ($szPathlist, "*") - 1)
		Wend
	EndIf
	If StringLeft($szReturn, 1) = '*' Then $szReturn = StringTrimLeft($szReturn, 1)
	$szReturn = StringReplace($szReturn, '\\', '\')
	If StringRight($szReturn, 1) = '*' Then $szReturn = StringTrimRight($szReturn,1)
	$szReturn = StringSplit($oRoot & $szReturn,'*')
	If $szReturn = '*' or $szReturn = '' Then Return 0
	; _ArraySort($szReturn) ;; << uncomment and #include <array.au3> to return a sorted array
	Return $szReturn
EndFunc   ;<==> __FldrListToArray()

;;<<==  Helper functions  ==>>
;;
Func _FldrDate($Dt, $Ext_Date, $Mth_AsText, $T_Txt)
   Local $Tday = 0
   If $Ext_Date = 0 Then Return $Dt
   Local $Disp_Mon = StringSplit('January|February|March|April|May|June|July|August|September|October|November|December', '|')
   Local $y = StringLeft($Dt, 4)
   Local $m = StringMid($Dt,5,2)
   Local $d = StringMid($Dt, 7, 2)
   If $y = @Year AND $m = @Mon AND $d = @Mday Then $Tday = 1
   Local $t = StringMid($Dt, 9)
   $t = StringLeft($t,2) & ':' & StringMid($t, 3,2) & ':' & StringRight($t, 2)
   If StringLeft( $t, 2) < 12 Then
      $t &= ' am'
   Else
      $t = StringLeft($t, 2) - 12 & StringMid($t, 3)
      $t &= ' pm'
   EndIf
   If $Tday = 1 AND $Mth_AsText = 1 AND $T_Txt = 1 Then Return 'Today at ' & $t
   If $Mth_AsText = 1 Then $m = $Disp_Mon[$m]
   Return $m & ' ' & $d & ' ' & $y & ' at ' & $t
EndFunc    ;<===> _FldrDate()
